/**
Macromedia Flash File common definitions.
Copyright (C) 2004  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _SWF_H_
#define _SWF_H_

/**
 *                      E N U M S 
 **/
enum TagType { 
	stagEnd 				= 0,
	stagShowFrame 			= 1,
	stagDefineShape			= 2,
	stagFreeCharacter 		= 3,
	stagPlaceObject 		= 4,
	stagRemoveObject 		= 5,
	stagDefineBits 			= 6,
	stagDefineButton 		= 7,
	stagJPEGTables 			= 8,
	stagSetBackgroundColor	= 9,
	stagDefineFont			= 10,
	stagDefineText			= 11,
	stagDoAction			= 12,
	stagDefineFontInfo		= 13,
	stagDefineSound			= 14,	
	stagStartSound			= 15,
	stagStopSound			= 16,
	stagDefineButtonSound	= 17,
	stagSoundStreamHead		= 18,
	stagSoundStreamBlock	= 19,
	stagDefineBitsLossless	= 20,	
	stagDefineBitsJPEG2		= 21,	
	stagDefineShape2		= 22,
	stagDefineButtonCxform	= 23,
	stagProtect				= 24,	
	stagPlaceObject2		= 26,
	stagRemoveObject2		= 28,
	stagDefineShape3		= 32,
	stagDefineText2			= 33,
	stagDefineButton2		= 34,
	stagDefineBitsJPEG3		= 35,
	stagDefineBitsLossless2 = 36,
	stagDefineEditText		= 37,
	stagDefineSprite		= 39,
	stagNameCharacter		= 40,
	stagFrameLabel			= 43,
	stagSoundStreamHead2	= 45,
	stagDefineMorphShape	= 46,
	stagDefineFont2			= 48,
	stagExportAssets		= 56,
	stagImportAssets		= 57,
	stagEnableDebugger		= 58,
	stagDoInitAction		= 59,
	stagDefineVideoStream	= 60,
	stagVideoFrame			= 61,
	stagDefineFontInfo2		= 62,
	stagEnableDebugger2		= 64,
	stagScriptLimits		= 65,
	stagSetTabIndex			= 66,
} ;

// Actions
enum Action {
	// SWF3 actions
	ActionGotoFrame		= 0x81,
	ActionGetURL		= 0x83,
	ActionNextFrame		= 0x04,
	ActionPrevFrame		= 0x05,
	ActionPlay			= 0x06,
	ActionStop			= 0x07,
	ActionToggleQuality	= 0x08,
	ActionStopSounds	= 0x09,
	ActionWaitForFrame	= 0x8a,
	ActionSetTarget		= 0x8b,
	ActionGoToLabel		= 0x8c,

	// SWF4 actions
	ActionPush			= 0x96,
	ActionPop			= 0x17,
	ActionAdd			= 0x0a,
	ActionSubstract		= 0x0b,
	ActionMultiply		= 0x0c,
	ActionDivide		= 0x0d,
	ActionEqual			= 0x0e,
	ActionLess			= 0x0f,
	ActionAnd			= 0x10,
	ActionOr			= 0x11,	
	ActionNot			= 0x12,
	ActionStringEquals	= 0x13,
	ActionStringLength 	= 0x14,
	ActionStringAdd		= 0x21,
	ActionStringExtract	= 0x15,
	ActionStringLess	= 0x29,
	ActionMBStringLength= 0x31,
	ActionMBStringExtract=0x35,
	ActionToInteger		= 0x18,
	ActionCharToAscii	= 0x32,
	ActionAsciiToChar	= 0x33,
	ActionMBCharToAscii	= 0x36,
	ActionMBAsciiToChar	= 0x37,
	ActionJump			= 0x99,
	ActionIf			= 0x9d,
	ActionCall			= 0x9e,
	ActionGetVariable	= 0x1c,
	ActionSetVariable	= 0x1d,
	ActionGetURL2		= 0x9a,
	ActionGotoFrame2 	= 0x9f,
	ActionSetTarget2	= 0x20,
	ActionGetProperty	= 0x22,
	ActionSetProperty	= 0x23,
	ActionCloneSprite	= 0x24,
	ActionRemoveSprite	= 0x25,
	ActionStartDrag		= 0x27,
	ActionEndDrag		= 0x28,
	ActionWaitForFrame2	= 0x8d,
	ActionTrace			= 0x26,
	ActionGetTime		= 0x34,
	ActionRandomNumber	= 0x30,

	// SWF5 actions
	ActionCallFunction	= 0x3d,
	ActionCallMethod	= 0x52,
	ActionConstantPool	= 0x88,
	ActionDefineFunction= 0x9b,
	ActionDefineLocal	= 0x3c,
	ActionDefineLocal2	= 0x41,
	ActionDelete		= 0x3a,
	ActionDelete2		= 0x3b,
	ActionEnumerate		= 0x46,
	ActionEquals2		= 0x49,
	ActionGetMember		= 0x4e,
	ActionInitArray		= 0x42,
	ActionInitObject	= 0x43,
	ActionNewMethod		= 0x53,
	ActionNewObject		= 0x40,
	ActionSetMember		= 0x4f,
	ActionTargetPath	= 0x45,
	ActionWith			= 0x94,
	ActionToNumber		= 0x4a,
	ActionToString		= 0x4b,
	ActionTypeOf		= 0x44,
	ActionAdd2			= 0x47,
	ActionLess2			= 0x48,
	ActionModulo		= 0x3f,
	ActionBitAnd		= 0x60,
	ActionBitLShift		= 0x63,
	ActionBitOr			= 0x61,
	ActionBitRShift		= 0x64,
	ActionBitURShift	= 0x65,
	ActionBitXor		= 0x62,
	ActionDecrement		= 0x51,
	ActionIncrement		= 0x50,
	ActionPushDuplicate = 0x4c,
	ActionReturn		= 0x3e,
	ActionStackSwap		= 0x4d,
	ActionStoreRegister	= 0x87,
	
	// SWF6 actions
	DoInitAction		= 0x59,
	ActionInstanceOf	= 0x54,
	ActionEnumerate2	= 0x55,
	ActionStrictEquals	= 0x66,
	ActionGreater		= 0x67,
	ActionStringGreater	= 0x68,
	
	// SWF7 actions
	ActionDefineFunction2=0x8e,
	ActionExtends		= 0x69,
	ActionCastOp		= 0x2b,
	ActionImplementsOp	= 0x2c,
	ActionTry			= 0x8f,
	ActionThrow			= 0x2a
};

enum RecordType {
	EndShapeRecordType		= 0x00,
	StyleChangeRecordType	= 0x01,
	StraightEdgeRecordType	= 0x02,
	CurvedEdgeRecordType	= 0x03,
	FlushShapeRecordType	= 0x04	// Internal use
};

enum MouseAction {
	MouseActionPress = 0,
	MouseActionRelease = 1,
	MouseActionOver = 2
};

/**
 *                      T Y P E D E F S 
 **/
typedef uint8_t  UI8;
typedef uint16_t UI16;
typedef uint32_t UI32;
typedef int8_t   SI8;
typedef int16_t  SI16;
typedef int32_t  SI32;


/**
 *						S T R U C T S
 **/
typedef struct {
	long xmin;
	long xmax;
	long ymin;
	long ymax;
} RECT;

typedef struct {
	UI8 red;
	UI8 green;
	UI8 blue;
} RGB;

typedef struct {
	UI8 red;
	UI8 green;
	UI8 blue;
	UI8	alpha;
} RGBA;

typedef struct {
	UI16	width;
	RGBA	color;
} LINESTYLE;

typedef struct  {
	bool	hasScale;
	long	scaleX;
	long	scaleY;
	bool	hasRotate;
	long	rotateSkew0;
	long	rotateSkew1;
	long	translateX;
	long	translateY;
} MATRIX;

typedef struct {
	bool	clipEventKeyUp;
	bool	clipEventKeyDown;
	bool	clipEventMouseUp;
	bool	clipEventMouseDown;
	bool	clipEventMouseMove;
	bool	clipEventUnload;
	bool	clipEventEnterFrame;
	bool	clipEventLoad;
	bool	clipEventDragOver;
	bool	clipEventRollOut;
	bool	clipEventRollOver;
	bool	clipEventReleaseOutside;
	bool	clipEventRelease;
	bool	clipEventPress;
	bool	clipEventInitialize;
	bool	clipEventData;
	bool	clipEventConstruct;
	bool	clipEventKeyPress;
	bool	clipEventDragOut;
} ClipEventFlags;


typedef struct {
	UI8   signature1;
	UI8	  signature2;
	UI8	  signature3;
	UI8	  version;
	UI32  fileLength;
	RECT  frameSize;
	float frameRate;
	UI16  frameCount;
} HEADER;

typedef struct {
	bool	hasAddTerms;
	bool	hasMultTerms;	
	long 	redMultTerm;
	long	greenMultTerm;
	long 	blueMultTerm;
	long	redAddTerm;
	long	greenAddTerm;
	long	blueAddTerm;
} CXFORM;

typedef struct {
	bool	hasAddTerms;
	bool	hasMultTerms;	
	long 	redMultTerm;
	long	greenMultTerm;
	long 	blueMultTerm;
	long	alphaMultTerm;
	long	redAddTerm;
	long	greenAddTerm;
	long	blueAddTerm;
	long	alphaAddTerm;
} CXFORMWITHALPHA;

typedef struct {
	long	glyphIndex;
	long	glyphAdvance;
} GLYPHENTRY;

typedef UI8 LANGCODE;

typedef struct {
	UI16	fontKerningCode1;
	UI16	fontKerningCode2;
	SI16	fontKerningAdjustment;
} KERNINGRECORD;

typedef struct {
	bool	buttonStateHitTest;
	bool	buttonStateDown;	
	bool	buttonStateOver;
	bool	buttonStateUp;
	UI16	characterID;
	bool	placeDepth;
	bool	hasColorTransform;
	MATRIX 	placeMatrix;
	CXFORMWITHALPHA colorTransform;
} BUTTONRECORD;

typedef struct {
	UI32	pos44;
	UI16	leftLevel;
	UI16	rightLevel;
} SOUNDENVELOPE;

typedef struct {
	UI16	startWidth;
	UI16	endWidth;
	RGBA	startColor;
	RGBA	endColor;
} MORPHLINESTYLE;

typedef struct {
	UI8		startRatio;
	RGBA	startColor;
	UI8		endRatio;
	RGBA	endColor;
} MORPHGRADRECORD;

typedef struct {
	UI32 pictureStartCode;
	UI8	 version;
	UI8	 temporalReference;
	UI8	 pictureSize;
	UI16 customWidth;
	UI16 customHeight;
	UI8	 pictureType;
	bool deblockingFlag;
	UI8	 quantizer;
} H263VIDEOPACKET;

typedef struct {
	int x,y;		// mouse coodinates
	int	mouseAction;
} EventDataCallback;


/**
 *						C L A S S E S 
 **/

/**
 * A gradient record
 **/
class GRADRECORD{
public:
	GRADRECORD () { };
	~GRADRECORD() {} ;
	UI8		getRatio() { return ratio;};
	RGBA	*getColor() { return &color; };
	void	setRatio(UI8 p) { ratio = p;};
	void	setColor(RGBA p) { color = p; };
private:
	UI8		ratio;
	RGBA	color;
} ;

/**
 * A gradient
 **/
class GRADIENT {
public:
	GRADIENT();
	GRADIENT(GRADIENT *p);
	~GRADIENT();
	UI8		getNumGradients() { return numGradients;};
	list<GRADRECORD*> *getGradientRecords() { return gradientRecords;};
	void	setNumGradients(UI8 p) { numGradients = p;};
	void 	setGradientRecords(list<GRADRECORD*> p) { *gradientRecords = p;};
	void 	addGradientRecord(GRADRECORD *p) { gradientRecords->push_back(p); }
private:
	UI8		numGradients;
	list<GRADRECORD*> *gradientRecords;
};

/**
 * A fill style
 **/
class FILLSTYLE {
public:
	FILLSTYLE() { gradient = NULL; }
	~FILLSTYLE();
	UI8		getFillStyleType() { return fillStyleType;};
	RGBA	*getColor() { return &color;};
	MATRIX  *getGradientMatrix() { return &gradientMatrix;};
	GRADIENT *getGradient() { return gradient;};
	UI16	getBitmapId() { return bitmapId;};
	MATRIX 	*getBitmapMatrix() { return &bitmapMatrix;};
	void	setFillStyleType(UI8 p) { fillStyleType = p;};
	void	setColor(RGBA p) { color = p;};
	void  	setGradientMatrix(MATRIX p) { gradientMatrix = p;};
	void	setGradient(GRADIENT *p) { gradient = p;};
	void	setBitmapId(UI16 p) { bitmapId = p;};
	void	setBitmapMatrix(MATRIX p) { bitmapMatrix = p;};
private:
	UI8		fillStyleType;
	RGBA	color;
	MATRIX  gradientMatrix;
	GRADIENT *gradient;
	UI16	bitmapId;
	MATRIX 	bitmapMatrix;
};

/**
 * An action clip record
 **/
class ClipActionRecord {
public:
	ClipActionRecord() { code = NULL;}
	~ClipActionRecord();
	ClipEventFlags 	getClipEventFlags() { return clipEventFlags;};
	UI32	getActionRecordSize() { return actionRecordSize;};
	UI8		getKeyCode() { return keyCode;};
	void	setClipEventFlags(ClipEventFlags p) { clipEventFlags =p;};
	void	setActionRecordSize(UI32 p) { actionRecordSize =p;};
	void	setKeyCode(UI8 p) { keyCode =p;};
	void 	setCode(UI8 *p) { code = p; }
	UI8* 	getCode() { return code; }
private:
	ClipEventFlags 	clipEventFlags;
	UI32			actionRecordSize;
	UI8				keyCode;
	UI8*			code;
};

/**
 * Clip Actions
 **/
class ClipActions {
public:
	ClipActions() { };
	~ClipActions();
	ClipEventFlags	getAllEventFlags() { return allEventFlags; };
	list<ClipActionRecord*> *getClipActionRecords() { return &clipActionRecords;};
	void	setAllEventFlags(ClipEventFlags p) { allEventFlags = p; };
	void 	addActionRecord(ClipActionRecord *p) { clipActionRecords.push_back(p); };
private:
	ClipEventFlags	allEventFlags;
	list<ClipActionRecord*> clipActionRecords;
};

/**
 * Unicode String (Flash >5)
 **/
class STRING {
public:
	STRING() {  };
	~STRING() {  }
	void 	setString(char *p, bool isUtf8) { wstr = isUtf8 ? utf8Towstring(p) : extentedAsciiTowstring(p); };
	void 	setLen(int p) { len = p; };
	wstring getString() { return wstr; };
	int		getLen() { return len; };
private:
	wstring wstr;
	int		len;
};

/**
 * A text record
 **/
class TEXTRECORD {
public:
	TEXTRECORD() { glyphEntries = NULL; }
	~TEXTRECORD() { if (glyphEntries!=NULL) delete []glyphEntries; }
	bool	getStyleFlagsHasFont() { return styleFlagsHasFont; };
	bool	getStyleFlagsHasColor() { return styleFlagsHasColor; };
	bool	getStyleFlagsHasYOffset() { return styleFlagsHasYOffset; };
	bool	getStyleFlagsHasXOffset() { return styleFlagsHasXOffset; };
	UI16	getFontID() { return fontID; };
	RGBA	getTextColor() { return textColor; };
	SI16	getXOffset() { return xOffset; };
	SI16	getYOffset() { return yOffset; };
	UI16	getTextHeight() { return textHeight; };
	UI8		getGlyphCount() { return glyphCount; };
	GLYPHENTRY* getGlyphEntries() { return glyphEntries; };
	void	setStyleFlagsHasFont(bool p) { styleFlagsHasFont =p; };
	void	setStyleFlagsHasColor(bool p) { styleFlagsHasColor =p; };
	void	setStyleFlagsHasYOffset(bool p) { styleFlagsHasYOffset =p; };
	void	setStyleFlagsHasXOffset(bool p) { styleFlagsHasXOffset =p; };
	void	setFontID(UI16 p) { fontID =p; };
	void	setTextColor(RGBA p) { textColor =p; };
	void	setXOffset(SI16 p) { xOffset =p; };
	void	setYOffset(SI16 p) { yOffset =p; };
	void	setTextHeight(UI16 p) { textHeight =p; };
	void	setGlyphCount(UI8 p) { glyphCount =p; };
	void	setGlyphEntries(GLYPHENTRY* p) { glyphEntries =p; };
private:
	bool	styleFlagsHasFont;
	bool	styleFlagsHasColor;
	bool	styleFlagsHasYOffset;
	bool	styleFlagsHasXOffset;
	UI16	fontID;
	RGBA	textColor;
	SI16	xOffset;
	SI16	yOffset;
	UI16	textHeight;
	UI8		glyphCount;
	GLYPHENTRY* glyphEntries;
};

/**
 * A buttonCondACtion
 **/
class BUTTONCONDACTION {
public:
	BUTTONCONDACTION() {  code = NULL;}
	~BUTTONCONDACTION();
	UI16	getCondActionSize() { return condActionSize;};
	bool	getCondIdleToOverDown() { return condIdleToOverDown;};
	bool	getCondOutDownToIdle() { return condOutDownToIdle;};
	bool	getCondOutDownToOverDown() { return condOutDownToOverDown;};
	bool	getCondOverDownToOutDown() { return condOverDownToOutDown;};
	bool	getCondOverDownToOverUp() { return condOverDownToOverUp;};
	bool	getCondOverUpToOverDown() { return condOverUpToIdle;};
	bool	getCondOverUpToIdle() { return condIdleToOverUp;};
	bool	getCondIdleToOverUp() { return condKeyPress;};
	UI8		getCondKeyPress() { return condKeyPress;};
	bool	getCondOverDownToIdle() { return condOverDownToIdle;};
	void	setCondActionSize(UI16 p) { condActionSize =p;};
	void	setCondIdleToOverDown(bool p) { condIdleToOverDown =p;};
	void	setCondOutDownToIdle(bool p) { condOutDownToIdle =p;};
	void	setCondOutDownToOverDown(bool p) { condOutDownToOverDown =p;};
	void	setCondOverDownToOutDown(bool p) { condOverDownToOutDown =p;};
	void	setCondOverDownToOverUp(bool p) { condOverDownToOverUp =p;};
	void	setCondOverUpToOverDown(bool p) { condOverUpToIdle =p;};
	void	setCondOverUpToIdle(bool p) { condIdleToOverUp =p;};
	void	setCondIdleToOverUp(bool p) { condKeyPress =p;};
	void	setCondKeyPress(UI8 p) { condKeyPress =p;};
	void	setCondOverDownToIdle(bool p) { condOverDownToIdle =p;};
	void 	setCode(UI8* p) { code = p; }
	UI8*	getCode() { return code; }	
private:	
	UI16	condActionSize;
	bool	condIdleToOverDown;
	bool	condOutDownToIdle;
	bool	condOutDownToOverDown;
	bool	condOverDownToOutDown;
	bool	condOverDownToOverUp;
	bool	condOverUpToOverDown;
	bool	condOverUpToIdle;
	bool	condIdleToOverUp;
	UI8		condKeyPress;
	bool	condOverDownToIdle;
	UI8*	code;
};

/**
 * A sound info
 **/
class SOUNDINFO {
public:
	SOUNDINFO() { envelopeRecords = NULL; }
	~SOUNDINFO() { if (envelopeRecords != NULL) delete []envelopeRecords; }
	bool	getSyncStop() { return syncStop; };
	bool	getSyncNoMultiple() { return syncNoMultiple; };
	bool	getHasEnvelope() { return hasEnvelope; };
	bool	getHasLoops() { return hasLoops; };
	bool	getHasOutPoint() { return hasOutPoint; };
	bool	getHasInPoint() { return hasInPoint; };
	UI32	getInPoint() { return inPoint; };
	UI32	getOutPoint() { return outPoint; };
	UI16	getLoopCount() { return loopCount; };
	UI8		getEnvPoints() { return envPoints; };
	SOUNDENVELOPE *getEnvelopeRecords() { return envelopeRecords; };
	void	setSyncStop(bool p) { syncStop =p; };
	void	setSyncNoMultiple(bool p) { syncNoMultiple =p; };
	void	setHasEnvelope(bool p) { hasEnvelope =p; };
	void	setHasLoops(bool p) { hasLoops =p; };
	void	setHasOutPoint(bool p) { hasOutPoint =p; };
	void	setHasInPoint(bool p) { hasInPoint =p; };
	void	setInPoint(UI32 p) { inPoint =p; };
	void	setOutPoint(UI32 p) { outPoint =p; };
	void	setLoopCount(UI16 p) { loopCount =p; };
	void	setEnvPoints(UI8 p) { envPoints =p; };
	void	setEnvelopeRecords(SOUNDENVELOPE * p) { envelopeRecords =p; };
private:
	bool	syncStop;
	bool	syncNoMultiple;
	bool	hasEnvelope;
	bool	hasLoops;
	bool	hasOutPoint;
	bool	hasInPoint;
	UI32	inPoint;
	UI32	outPoint;
	UI16	loopCount;
	UI8		envPoints;
	SOUNDENVELOPE *envelopeRecords;
};


/**
 * Morph styles
 **/
class MORPHLINESTYLES {
public:
	MORPHLINESTYLES() { lineStyles = NULL; }
	~MORPHLINESTYLES() { if (lineStyles != NULL) delete []lineStyles; }
	UI16	getLineStyleCount() { return lineStyleCount; };
	MORPHLINESTYLE* getLineStyles() { return lineStyles; };
	void	setLineStyleCount(UI16 p) { lineStyleCount =p; };
	void	setLineStyles(MORPHLINESTYLE* p) { lineStyles =p; };
private:
	UI16	lineStyleCount;
	MORPHLINESTYLE* lineStyles;
};

/**
 * A morph gradient
 **/
class MORPHGRADIENT {
public:
	MORPHGRADIENT() { }
	~MORPHGRADIENT();
	UI8		getNumGradients() { return numGradients; };
	list<MORPHGRADRECORD*> *getGradientRecords() { return &gradientRecords; };
	void	setNumGradients(UI8 p) { numGradients =p; };
	void	addGradientRecord(MORPHGRADRECORD* p) { gradientRecords.push_back(p); };
private:
	UI8		numGradients;
	list<MORPHGRADRECORD*> gradientRecords;
};

/**
 * A morph style
 **/
class MORPHFILLSTYLE {
public:
	MORPHFILLSTYLE() { gradient = NULL;}
	~MORPHFILLSTYLE() { if (gradient  != NULL) delete gradient; }
	UI8		getFillStyleType() { return fillStyleType;};
	RGBA	*getStartColor() { return &startColor;};
	RGBA	*getEndColor() { return &endColor;};
	MATRIX	*getStartGradientMatrix() { return &startGradientMatrix;};
	MATRIX	*getEndGradientMatrix() { return &endGradientMatrix;};
	MORPHGRADIENT *getGradient() { return gradient;};
	UI16	getBitmapId() { return bitmapId;};
	MATRIX	*getStartBitmapMatrix() { return &startBitmapMatrix;};
	MATRIX	*getEndBitmapMatrix() { return &endBitmapMatrix;};
	void	setFillStyleType(UI8 p) { fillStyleType =p;};
	void	setStartColor(RGBA p) { startColor =p;};
	void	setEndColor(RGBA p) { endColor =p;};
	void	setStartGradientMatrix(MATRIX p) { startGradientMatrix =p;};
	void	setEndGradientMatrix(MATRIX p) { endGradientMatrix =p;};
	void	setGradient(MORPHGRADIENT *p) { gradient =p;};
	void	setBitmapId(UI16 p) { bitmapId =p;};
	void	setStartBitmapMatrix(MATRIX p) { startBitmapMatrix =p;};
	void	setEndBitmapMatrix(MATRIX p) { endBitmapMatrix =p;};
private:
	UI8		fillStyleType;
	RGBA	startColor;
	RGBA	endColor;
	MATRIX	startGradientMatrix;
	MATRIX	endGradientMatrix;
	MORPHGRADIENT *gradient;
	UI16	bitmapId;
	MATRIX	startBitmapMatrix;
	MATRIX	endBitmapMatrix;
};

/**
 * Morph Styles
 **/
class MORPHFILLSTYLES {
public:
	MORPHFILLSTYLES() { fillStyles = NULL; }
	~MORPHFILLSTYLES();
	UI16		getFillStyleCount() { return fillStyleCount; };
	MORPHFILLSTYLE *getFillStyles() { return fillStyles; };
	void	setFillStyleCount(UI16 p) { fillStyleCount =p; };
	void	setFillStyles(MORPHFILLSTYLE *p) { fillStyles =p; };
private:
	UI16		fillStyleCount;
	MORPHFILLSTYLE* fillStyles;
};

/**
 * Base class for Shape Record
 **/
class ShapeRecord {
public:
	virtual ~ShapeRecord() { }
	void setTypeFlag(UI8 p) { typeFlag=p; }
	UI8	 getTypeFlag() { return typeFlag; }
	virtual ShapeRecord*clone() { return new ShapeRecord(*this); }
private:
	UI8	typeFlag;
};

/**
 * an EndShapeREcord
 **/
class EndShapeRecord : public ShapeRecord {
public:
	UI8		getEndOfShape() { return endOfShape; };
	void	setEndOfShape(UI8 p) { endOfShape = p; };
	ShapeRecord*clone() { return new EndShapeRecord(*this); }
private:
	UI8	endOfShape;
};

/**
 * The style change record is also a non-edge record
 **/
class StyleChangeRecord : public ShapeRecord {
public:
	StyleChangeRecord();
	~StyleChangeRecord();
	ShapeRecord*clone();
	bool	getStateNewStyles() { return stateNewStyles; };
	bool	getStateLineStyle() { return  stateLineStyle;};
	bool	getStateFillStyle1() { return  stateFillStyle1; };
	bool	getStateFillStyle0() { return  stateFillStyle0; };
	bool	getStateMoveTo() { return  stateMoveTo; };
	long	getMoveDeltaX() { return  moveDeltaX;};
	long	getMoveDeltaY() { return  moveDeltaY;};
	long 	getFillStyle0() { return  fillStyle0;};
	long 	getFillStyle1() { return  fillStyle1;};
	long	getLineStyle() { return  lineStyle;};
	FILLSTYLE* getFillStyles() { return  fillStyles;};
	LINESTYLE* getLineStyles() { return  lineStyles;};
	UI16 	getNumFillStyles() { return  numFillStyles;};
	UI16	getNumLineStyles() { return  numLineStyles;};
	UI8		getNumFillBits() { return numFillBits; };
	UI8		getNumLineBits() { return numLineBits; };

	void	setStateNewStyles( bool p) { stateNewStyles = p; };
	void	setStateLineStyle(bool p) {  stateLineStyle = p;};
	void	setStateFillStyle1(bool p) {  stateFillStyle1 = p; };
	void	setStateFillStyle0(bool p) {  stateFillStyle0 = p; };
	void	setStateMoveTo(bool p) { stateMoveTo = p; };
	void	setMoveDeltaX(long p) {  moveDeltaX = p;};
	void	setMoveDeltaY(long p) {  moveDeltaY = p;};
	void	setFillStyle0(long p) {  fillStyle0 = p;};
	void	setFillStyle1(long p) {  fillStyle1 = p;};
	void	setLineStyle(long  p) {  lineStyle = p;};
	void	setFillStyles(FILLSTYLE * p) { fillStyles = p;};
	void	setLineStyles(LINESTYLE * p) { lineStyles = p;};
	void	setNumFillStyles(UI16 p) { numFillStyles = p;};
	void	setNumLineStyles(UI16 p) { numLineStyles = p;};
	void	setNumFillBits(UI8 p) { numFillBits = p; };
	void	setNumLineBits(UI8 p) { numLineBits = p; };

private: 
	bool	stateNewStyles;
	bool	stateLineStyle;
	bool	stateFillStyle1;
	bool	stateFillStyle0;
	bool	stateMoveTo;
	long	moveDeltaX;
	long	moveDeltaY;
	long 	fillStyle0;
	long 	fillStyle1;
	long	lineStyle;
	FILLSTYLE *fillStyles;
	LINESTYLE *lineStyles;
	UI16 	numFillStyles;
	UI16	numLineStyles;
	UI8		numFillBits;
	UI8		numLineBits;
};

/**
 * The StraightEdgeRecord stores the edge as an X-Y delta
 **/
class StraightEdgeRecord : public ShapeRecord {
public:
	StraightEdgeRecord();
	ShapeRecord*clone();
	bool	getStraightFlag() { return straightFlag;};
	bool	getGeneralLineFlag() { return generalLineFlag;};
	long 	getDeltaX() { return deltaX;};
	long	getDeltaY() { return deltaY;};
	bool	getVertLineFlag() { return vertLineFlag;};
	long 	getDeltaVert() { return deltaVert;};
	void	setStraightFlag(bool p) { straightFlag = p;};
	void	setGeneralLineFlag(bool p) { generalLineFlag = p;};
	void 	setDeltaX(long p) { deltaX = p;};
	void	setDeltaY(long p) { deltaY = p;};
	void	setVertLineFlag(bool p) { vertLineFlag = p;};
	void	setDeltaVert(long p) { deltaVert = p;};

private: 
	bool	straightFlag;
	bool	generalLineFlag;
	long 	deltaX;
	long	deltaY;
	bool	vertLineFlag;
	long 	deltaVert;
};

/**
 * Quadratic Bezier curve and a Cubic Bezier curve
 **/
class CurvedEdgeRecord : public ShapeRecord {
public:
	CurvedEdgeRecord() { setTypeFlag(CurvedEdgeRecordType); }
	ShapeRecord*clone();
	bool	getStraightFlag() { return straightFlag; };
	long	getControlDeltaX() { return controlDeltaX; };
	long 	getControlDeltaY() { return controlDeltaY; };
	long	getAnchorDeltaX() { return anchorDeltaX; };
	long	getAnchorDeltaY() { return anchorDeltaY; };
	void	setStraightFlag(bool p) { straightFlag = p; };
	void	setControlDeltaX(long p) { controlDeltaX = p; };
	void	setControlDeltaY(long p) { controlDeltaY = p; };
	void	setAnchorDeltaX(long p) { anchorDeltaX = p; };
	void	setAnchorDeltaY(long p) { anchorDeltaY = p; };

private:
	bool	straightFlag;
	long	controlDeltaX;
	long 	controlDeltaY;
	long	anchorDeltaX;
	long	anchorDeltaY;
};

/**
 * an FlusRecord - Not in MM specs, but neede we we concatenate swf defined shapes with AS drawing commands
 **/
class FlushShapeRecord : public ShapeRecord {
public:
	FlushShapeRecord() { setTypeFlag(FlushShapeRecordType); }
	ShapeRecord*clone() { 
		return new FlushShapeRecord(*this);
	}
};

/**
 * Stores a Shape
 **/
class Shape {
public:
	Shape();
	~Shape();
	Shape(Shape *p);
	UI8			getNumFillBits() { return numFillBits; };
	UI8			getNumLineBits() { return numLineBits; };
	list<ShapeRecord*> *getShapeRecords() { return shapeRecords; };
	void 		addShapeRecord(ShapeRecord *p) { shapeRecords->push_back(p); }
	void		setNumFillBits(UI8 p) { numFillBits = p; };
	void		setNumLineBits(UI8 p) { numLineBits = p; };
	bool		getIsShapeWithStyle() { return isShapeWithStyle; }
protected:
	bool		isShapeWithStyle;
private:
	UI8			numFillBits;
	UI8			numLineBits;
	list<ShapeRecord*> *shapeRecords;
};

/**
 * Stores a Shape width style
 **/
class ShapeWithStyle : public Shape {
public:
	ShapeWithStyle();
	~ShapeWithStyle();
	ShapeWithStyle(ShapeWithStyle *p);
	FILLSTYLE* 	getFillStyles() { return fillStyles; };
	LINESTYLE*	getLineStyles() { return lineStyles; };
	UI16		getNumFillStyles() { return numFillStyles; };
	UI16		getNumLineStyles() { return numLineStyles; };
	void	 	setFillStyles(FILLSTYLE* p) { fillStyles = p; };
	void		setLineStyles(LINESTYLE* p) { lineStyles = p; };
	void		setNumFillStyles(UI16 p) { numFillStyles = p; };
	void		setNumLineStyles(UI16 p) { numLineStyles = p; };
private:
	FILLSTYLE* 	fillStyles;
	LINESTYLE*	lineStyles;
	UI16		numFillStyles;
	UI16		numLineStyles;
};

/**
 * An image class (used in Bimaps)
 **/
class Image {
public:
	Image() ;
	~Image();
	int		getWidth() { return width; }
	int		getHeight() { return height; } 
	int		getBpl() { return bpl; } 
	int 	getDepth() { return depth; }
	int		getNbColors()  { return nbColors; }
	RGBA*	getColormap() { return colormap; }
	UI8*	getPixels() { return pixels; }
	UI8*	getAlphaBuf() { return alpha_buf; }
	void	setWidth(int p) { width =p; }
	void	setHeight(int p) { height =p; } 
	void	setBpl(int p) { bpl =p; } 
	void 	setDepth(int p) { depth =p; }	
	void	setNbColors(int p)  { nbColors =p; }
	void	setColormap(RGBA* p) { colormap =p; }
	void	setPixels(UI8* p) { pixels =p; }
	void	setAlphaBuf(UI8* p) { alpha_buf =p; }
private:
	int 	width;
	int 	height;
	int 	bpl;
	int 	depth;
	int 	nbColors;
	RGBA 	*colormap;
	UI8*	pixels;
	UI8 	*alpha_buf;
};


#endif /* _SWF_H_ */
